#define use_segmentation_mask 0 //$use_segmentation_mask

#define global_opacity 1024.0

varying vec3 vertex,normal;	

uniform float min_level,max_level, step_length;
uniform vec3 pos;		
uniform vec3 nav;	
uniform vec3 cell_size;	
uniform vec3 cell_size_block;
uniform vec4 params;	
uniform float width,height;	
uniform vec3 box1,box2;
uniform vec3 txt_box1,txt_box2;
uniform vec4 random_seed;

uniform sampler2D screen_text;
uniform sampler2D distance_map_text;
uniform sampler3D f_text;
uniform sampler3D f_text_i;		
uniform sampler2D transfer_function;

uniform vec3 RFrom;
uniform vec3 GFrom;
uniform vec3 BFrom;

uniform vec3 gbox1,gbox2;


const float z_near=0.3;
const float z_far=60.0;


float Equ(vec3 arg)
{
	return texture3D(f_text, (arg-txt_box1)/(txt_box2-txt_box1)).x;

}





bool IntersectBox ( vec3 Origin,vec3 Direction, vec3 minimum, vec3 maximum, out float start, out float final )
{
	vec3 OMAX = ( minimum - Origin ) / Direction;
	vec3 OMIN = ( maximum - Origin ) / Direction;
	vec3 MAX = max ( OMAX, OMIN );
	vec3 MIN = min ( OMAX, OMIN );
	final = min ( MAX.x, min ( MAX.y, MAX.z ) );
	start = max ( max ( MIN.x, 0.0), max ( MIN.y, MIN.z ) );	
	return final > start;
}

#if use_segmentation_mask
float Equ_i(in vec3 arg)
{

	return texture3D(f_text_i, (arg-gbox1)/(gbox2-gbox1)).x;
	
}
#endif

float GetDepth(vec3 ps)
{
	ps -= pos;

	return clamp(z_far/(z_far-z_near) - (z_far*z_near/(z_far-z_near))/(dot(ps,nav)),0.01,0.99);
}
float rand(vec4 co)
{
	return fract(sin(dot(co,random_seed)) * 1000.0);
}
void main()
{

	vec3 ray = nav;
	vec4 ps = vec4(vertex.xyz-nav*dot(nav,vertex-pos),0.0);

	
	vec4 step  = vec4(ray*step_length,step_length);


	float e=0.0,e0=0.0, start,final;	

	vec2 txt_coord = gl_FragCoord.xy/vec2(width,height);
	vec4 color=texture2D(screen_text, txt_coord);
	vec4 dist_to_polygon = texture2D(distance_map_text, txt_coord).xyzw;
	

	if(color.w<0.98 && IntersectBox (ps.xyz,ray,box1,box2,start,final ))
	{
		//if(dist_to_polygon.w!=0.0)
		final = min(final,dist_to_polygon.w);
		start = max(start,0.0);
float op0;


		op0 = floor(-e0+start/step_length)+1.0;
		
		ps = ps + step*op0;
		
		ps = ps - step*(rand(vec4(gl_FragCoord.xy,pos.xy)));
		if(ps.w<start)ps+=step;
	

		float max_val=color.w*(max_level-min_level)+min_level;
		for (float itt = 0.0; ps.w<=final && itt < float ( 2000.0 ); itt+=1.0 )
		{
			#if use_segmentation_mask
			if(Equ_i(ps.xyz)==0.0)
			#endif
			{
			e = Equ(ps.xyz);
			if(e>max_val)
			{
				max_val=e;
				if(e>max_level)	break;
			}
			}
			ps += step;
		}
		
		//if(e>max_level)e=max_level;
		
		color = vec4(1.0,1.0,1.0,clamp((max_val-min_level)/(max_level-min_level),0.0,1.0));
		//color = vec4((e-min_level)/(max_level-min_level));
		
/*
		if(ps.w>dist_to_polygon.w)
		{
			color.xyz += dist_to_polygon.xyz*(1.0-color.w);
			color.w = 1.0;
		}
	*/	
	
	}
	
	gl_FragColor = color;
	
	
	
}
